package System::Introspector::Report::Publish::MediaWiki::Page;
use Moo;

use aliased 'System::Introspector::Report::Publish::MediaWiki::Parser';
use aliased 'System::Introspector::Report::Publish::MediaWiki::Producer';
use aliased 'System::Introspector::Report::Updater';

has name      => (is => 'ro', required => 1);
has timestamp => (is => 'ro', required => 1);
has content   => (is => 'rwp', required => 1);

my $_producer = Producer->new;
my $_parser   = Parser->new;
my $_updater  = Updater->new;

sub update {
  my ($self, $update_stream) = @_;
  my $original_stream = $_parser->parse($self->content);
  my $merged_stream   = $_updater->merge($original_stream, $update_stream);
  $self->_set_content($_producer->render($merged_stream));
  return 1;
}

1;
